package org.gcube.portlets.user.workspace.client.interfaces;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import org.gcube.portlets.user.workspace.client.ConstantsExplorer.ViewSwitchType;
import org.gcube.portlets.user.workspace.client.model.FileModel;
import org.gcube.portlets.user.workspace.client.model.FolderModel;
import org.gcube.portlets.user.workspace.client.model.MessageModel;


/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
//Implements this interface to receive events by tree async
public interface SubscriberInterface {
//	public void rescue(GuiEvent event);
//	public void renameItem(FileModel item, String newName, String extension);
//	public void deleteItem(FileModel item);
//	void addFolder(FolderModel itemFolder);
	void addedFile(String itemIdentifier, FileModel parent);
	void selectedItem(FileModel item, ArrayList<FileModel> parents);
	void expandFolderItem(FolderModel itemFolder);
	void setParentItemSelected(ArrayList <FileModel> listParents);	
	boolean renameItem(String itemIdentifier, String newName, String extension);
	boolean deleteItem(String itemIdentifier);
	void addedFolder(String itemIdentifier, FileModel parent);
	
	void rootLoaded(FileModel root);
	void smarthFolderSelected(String folderId, String category);
	void movedItems(String sourceParentIdentifier, FileModel targetParent);
	void loadSentMessages();
	void loadReceivedMessages(); //upload received messages
	void switchView(ViewSwitchType type);
	void deleteMessage(String id);
	void markAsReadMessage(String id, boolean isRead);
	void refreshFolder(FileModel fileModel);
//	void updatePrevieMessage(String fromLogin, String subject, String date, String body, List<FileModel> attachs);
	
	void updatePrevieMessage(MessageModel message);
	
	void createNewMessage(HashMap<String, String> hashAttachs);
	
	void forwardMessage(String fromLogin, String subject, List<String> listContactsLogin, Date date, HashMap<String, String> hashAttachs, String textMessage);
	void replyMessage(String fromLogin, String subject, List<String>listContactsLogin, Date date, String textMessage);
}
