package org.gcube.portlets.user.workspace.client.model;

import java.io.Serializable;

import org.gcube.portlets.user.workspace.client.ConstantsExplorer;
import org.gcube.portlets.user.workspace.client.interfaces.GXTFolderItemTypeEnum;
import org.gcube.portlets.user.workspace.client.resources.Resources;

import com.extjs.gxt.ui.client.data.BaseModelData;
import com.google.gwt.user.client.ui.AbstractImagePrototype;
import com.google.gwt.user.client.ui.Image;

/**
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class FileModel extends BaseModelData implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	protected GXTFolderItemTypeEnum test; //TODO da togliere

	protected FileModel(){
	}
	
//	public FileModel(String identifier, String name, String path, String parent, boolean isDirectory) {
//		setIdentifier(identifier);
//		setName(name);
//		setPath(path);
//		setCreationDate(creationDate);
//		setParent(parent);
//		setSize(size);
//		setIsDirectory(isDirectory);
//	}
//	
	public FileModel(String identifier, String name, FileModel parent, boolean isDirectory) {
		setIdentifier(identifier);
		setName(name);
//		setCreationDate(creationDate);
//		if(parent!=null)
		setParentFileModel(parent);
//		setSize(size);
		setIsDirectory(isDirectory);
	}
	
	/**
	 * USED FOR ATTACHMENTS AND FolderBulkCreator
	 * @param identifier
	 * @param name
	 * @param isDirectory
	 */
	public FileModel(String identifier, String name, boolean isDirectory) {
		setIdentifier(identifier);
		setName(name);
		setIsDirectory(isDirectory);
	}
	
	public FileModel(String identifier, String name, String type, GXTFolderItemTypeEnum folderItemTypeEnum, boolean isDirectory) {
		setIdentifier(identifier);
		setName(name);
		setType(type);
		setFolderItemType(folderItemTypeEnum);
		setIsDirectory(isDirectory);
	}
	
	public void setParentFileModel(FileModel parent) {
		set(ConstantsExplorer.PARENT,parent);
	}
	
	
	/**
	 * Status values
	 * 	ConstantsExplorer.FOLDERNOTLOAD = "notload";
	 *  ConstantsExplorer.FOLDERLOADED = "loaded";
	 * @param status
	 */
	public void setStatus(String status) {
		set("status", status);
	}
	
	public void setIcon() {
		
		AbstractImagePrototype absImgPr = null;
		
		if (!this.isDirectory()) {
			if(this.getType()!=null)
				absImgPr = Resources.getIconByType(this.getType());
//				absImgPr = Resources.getImageCancel();
			else
				absImgPr = Resources.getIconByFolderItemType(this.getGXTFolderItemType());
		}
		else
			absImgPr = Resources.getIconFolder();
		
		set(ConstantsExplorer.ICON, absImgPr.createImage());
		set(ConstantsExplorer.ABSTRACTICON, absImgPr);
	}
	
	public Image getIcon() {
		return (Image) get(ConstantsExplorer.ICON);
	}
	
	public AbstractImagePrototype getAbstractPrototypeIcon() {
		return (AbstractImagePrototype) get(ConstantsExplorer.ABSTRACTICON);
	}
	
	
	public String getStatus() {
		return get("status");
	}
	
	
	private void setIsDirectory(boolean flag){
		set(ConstantsExplorer.ISDIRECTORY, flag);
	}
	
	public void setIdentifier(String identifier) {
		set(ConstantsExplorer.IDENTIFIER, identifier);	
	}
	
	public String getIdentifier(){
		return get(ConstantsExplorer.IDENTIFIER);
	}
	
	public void setShortcutCategory(String category) {
		set(ConstantsExplorer.SHORTCUTCATEGORY, category);	
	}
	
	public String getShortcutCategory(){
		return get(ConstantsExplorer.SHORTCUTCATEGORY).toString();
	}
	

	private void setName(String name) {
		set(ConstantsExplorer.NAME, name);
	}
	
	public String getName() {
		return get(ConstantsExplorer.NAME);
	}
	
	public FileModel getParentFileModel(){
		return get(ConstantsExplorer.PARENT);
	}
	
	public boolean isDirectory(){
		return (Boolean) get(ConstantsExplorer.ISDIRECTORY);
	}
	
	@Override
	public boolean equals(Object obj) {
		if (obj != null && obj instanceof FileModel) {
			FileModel mobj = (FileModel) obj;
			return getIdentifier().equals(mobj.getIdentifier());
		}
		return super.equals(obj);
	}
	
	/**
	 * @return the isShared
	 */
	public boolean isShared() {
		return (Boolean) get(ConstantsExplorer.ISSHARED);
	}

	/**
	 * @param isShared the isShared to set
	 */
	public void setShared(boolean isShared) {
		set(ConstantsExplorer.ISSHARED, isShared);
	}
	
	/**
	 * It's: folder, myme type or unknown
	 * @param type
	 */
	public void setType(String type){
		set(ConstantsExplorer.TYPE, type);
	}
	
	public String getType(){
		return get(ConstantsExplorer.TYPE);
	}
	
	public void setFolderItemType(GXTFolderItemTypeEnum folderItemTypeEnum){
		set(ConstantsExplorer.FOLDERITEMTYPE, folderItemTypeEnum);
	}
	
//	public GXTFolderItemTypeEnum getGXTFolderItemType(){
//		return get(ConstantsExplorer.FOLDERITEMTYPE);
//	}
	
	
	public GXTFolderItemTypeEnum getGXTFolderItemType(){
		return (GXTFolderItemTypeEnum) get(ConstantsExplorer.FOLDERITEMTYPE);
	}
	
	public String getGXTFolderItemTypeToString(){
		return get(ConstantsExplorer.FOLDERITEMTYPE).toString();
	}


	
//	private void setSize(String size) {
//		set("size", size);	
//		
//	}
	

//	private void setParent(String parent) {
//		set("parent", parent);	
//		
//	}

//	private void setCreationDate(String creationDate) {
//		set("creationDate", creationDate);	
//		
//	}

//	public String getCreationDate(){
//		return get("creationDate");
//	}
//	

	
//	public String getLastModified(){
//		return get("lastModified");
//	}
//	

	
//	public void setGWTWorkspaceItem(GWTWorkspaceItem item){
//		set("gwtWorkspaceItem", item);
//	}
//	
//	public GWTWorkspaceItem getGWTWorkspaceItem(){
//		return get("gwtWorkspaceItem");
//	}
	
}
